/**********************************************************************
 * options.h                                                   May 1999
 * Horms                                             horms@vergenet.net
 *
 * Parse command line arguments
 * Code based on man getopt(3)
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef ARGUMENTS_BERT
#define ARGUMENTS_BERT

#include <stdio.h>
#include <string.h>
#include <gdbm.h>

#ifdef HAVE_CONFIG_H
#include "../config.h"
#else
#define HAVE_GETOPT_LONG
#endif

#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif

extern gdbm_error gdbm_errno;
extern char *gdbm_version;

#include "jain.h"

#define COPYRIGHT "(c) 1999 Horms <horms@vergenet.net>\nReleased under the GNU GPL\n"

typedef struct {
  char *mapname;
  int undo;
} makegdbm_options_t; 

extern char *optarg;
extern int optind, opterr, optopt;

makegdbm_options_t makegdbm_options(int argc, char **argv);
void usage(int exit_status);
void version(void);

#endif
