/**********************************************************************
 * daemon.h                                              September 1999
 * Horms                                             horms@vergenet.net
 *
 * Close and fork to become a daemon.
 *
 * Notes from unix programmer faq
 * http://www.landfield.com/faqs/unix-faq/programmer/faq/
 *
 * Almost none of this is necessary (or advisable) if your daemon is being
 * started by `inetd'.  In that case, stdin, stdout and stderr are all set up
 * for you to refer to the network connection, and the `fork()'s and session
 * manipulation should *not* be done (to avoid confusing `inetd').  Only the
 * `chdir()' and `umask()' steps remain as useful.
 *
 * Released under the terms of the GNU GPL
 * 
 **********************************************************************/

#ifndef DAEMON_FRUB
#define DAEMON_FRUB

#include <unistd.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>
#include <pwd.h>
#include <grp.h>
#include <signal.h>

#include "log.h"
#include "str.h"


void daemon_process(void);
void daemon_inetd_process(void);
void daemon_become_child(void);
void daemon_close_fd(void);
int daemon_setid(const char *user, const char *group);
void daemon_exit_cleanly(int i);
void daemon_noop_handler(int sig);


#endif
