/**********************************************************************
 * getserver.h                                            December 1999
 * Horms                                             horms@vergenet.net
 *
 * Access a database
 *
 * The database is accessed using the dlopen mechanism on a library.
 * See getserver.c for API details.
 *
 * Client server specification code courtesy of Daniel Rosen,
 * <droesen@entire-systems.com>. 
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef GETSERVER_FLIM
#define GETSERVER_FLIM

#include "options.h"
#include "server_port.h"
#include "log.h"
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <ctype.h>
#include <dlfcn.h>

server_port_t *getserver(
  char * key_str,
  int (*dbgetserver)(char *, char *, char **, size_t *)
);

int getserver_openlib(
  char *libname,
  char *opt_string,
  void **handle_return,
  int (**dbgetserver_return)(char *, char *, char **, size_t *)
);

int getserver_closelib(void *handle);

#endif
