/**********************************************************************
 * pop3_out.h                                            September 1999
 * Horms                                             horms@vergenet.net
 *
 * Talk POP3 to an upstream server
 *
 * Licenced under the GNU GPL
 *
 **********************************************************************/

#ifndef POP3_OUT_BLUM
#define POP3_OUT_BLUM

#include <pwd.h>
#include <sys/types.h>
#include <perdition_adt.h>

#include "token.h"
#include "pop3_write.h"
#include "perdition_types.h"
#include "queue_func.h"
#include "protocol_t.h"
#include "greeting.h"

int pop3_out_authenticate(
  const int in_fd,
  const int out_fd,
  const struct passwd *pw,
  const token_t *tag,
  const protocol_t *protocol,
  unsigned char *buf,
  size_t *n
);

int pop3_out_response(
  int in_fd,
  const char *tag_string,
  const token_t *desired_token,
  queue **q,
  unsigned char *buf,
  size_t *n
);

#endif
