/**********************************************************************
 * protocol_t.h                                          September 1999
 * Horms                                             horms@vergenet.net
 *
 * Types for genetic protoclol layer.
 *
 * NB: protocol_t.h (this file) and not protocol.h should
 *     be included by other source files
 *
 * Licenced under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef PROTOCOL_T_FLIM
#define PROTOCOL_T_FLIM

#include <perdition_adt.h>

#ifdef HAVE_CONFIG_H
#include "../config.h" 
#endif

#include <pwd.h>
#include <sys/types.h>
#include "token.h"

#define PROTOCOL_OK  0
#define PROTOCOL_ERR 1
#define PROTOCOL_NO  1
#define PROTOCOL_BAD 2

struct protocol_t_struct {
  char **type;
  int (*write)(
    const int, 
    const flag_t, 
    const token_t *, 
    const char *, 
    const char *
  );
  char *greeting_string;
  char *quit_string;
  char *one_time_tag;
  int (*in_get_pw)(const int, const int, struct passwd *return_pw, token_t **);
  int (*out_authenticate)(
    const int, 
    const int, 
    const struct passwd *,
    const token_t *tag,
    const struct protocol_t_struct *,
    unsigned char *buf,
    size_t *n
  );
  int (*in_authenticate)(
    const struct passwd *pw,
    const int err_fd,
    const token_t *tag
  );
  int (*out_response)(
    const int, 
    const char *, 
    const token_t *,
    queue **,
    unsigned char *buf,
    size_t *n
  );
  void (*destroy)(struct protocol_t_struct *);
  char *(*port)(char *);
}; 

typedef struct protocol_t_struct protocol_t;

#endif

